s=tf('s');

ejemplo = 1; %  2

if ejemplo==1

    % Efecto de ceros de FNM en la eleccin de polos de lazo cerrado

    close all

    G = (-s+2)/((s+1)*(s+4));

    C1 = pole_assign(G, [0], [ roots([1 2*0.9*2 4])' -1 -2 ]);
    [T1, S1, Su1, Si1]=calc_sensibilidades(G,C1);

    C2 = pole_assign(G, [0], [ roots([1 2*0.9*0.5 0.25])' -1 -2 ]);
    [T2, S2, Su2, Si2]=calc_sensibilidades(G,C2);

    C3 = pole_assign(G, [0], [ roots([1 2*0.9*4 16])' -1 -3 ]);
    [T3, S3, Su3, Si3]=calc_sensibilidades(G,C3);

    figure, step(T1, T2, T3), legend('T1','T2','T3'), grid on
    figure, bode(T1, T2, T3), legend('T1','T2','T3'), grid on

end

if ejemplo==2;

    % Tratando de dar con BW deseado

    close all

    G = 3/((s+1)*(s+4));

    C1 = pole_assign(G, [0 -2*j 2*j], [ roots([1 2*0.8*2 4])'  roots([1 2*0.9*5 25])' -1  -6 ]);
    [T1, S1, Su1, Si1]=calc_sensibilidades(G,C);
    y1 = lsim(T1, ones(size(t)), t) + lsim(Si1, [zeros(size(t(1:end/2))) 0.5*sin(2*t(end/2:end))], t) ...
        + lsim(S1, [zeros(size(t(1:end/3))) 0.5*sin(2*t(end/3:end))], t) ...
        + lsim(T1,[zeros(size(t(1:2*end/3))) 0.1*sin(10*t(2*end/3:end))],t);

    C2 = pole_assign(G, [0 -2*j 2*j], [ roots([1 2*0.8*1.8 1.8*1.8])'  roots([1 2*0.9*4 16])' -1  -3 ]);
    [T2, S2, Su2, Si2]=calc_sensibilidades(G,C2);
    y2 = lsim(T2, ones(size(t)), t) + lsim(Si2, [zeros(size(t(1:end/2))) 0.5*sin(2*t(end/2:end))], t) ...
        + lsim(S2, [zeros(size(t(1:end/3))) 0.5*sin(2*t(end/3:end))], t) ...
        + lsim(T2,[zeros(size(t(1:2*end/3))) 0.1*sin(10*t(2*end/3:end))],t);

    C3 = pole_assign(G, [0 -2*j 2*j], [ roots([1 2*0.8*1.5 1.5])'  roots([1 2*0.8*2 4])' -1  -4 ]);
    [T3, S3, Su3, Si3]=calc_sensibilidades(G,C3);
    y3 = lsim(T3, ones(size(t)), t) + lsim(Si3, [zeros(size(t(1:end/2))) 0.5*sin(2*t(end/2:end))], t) ...
        + lsim(S3, [zeros(size(t(1:end/3))) 0.5*sin(2*t(end/3:end))], t) ...
        + lsim(T3,[zeros(size(t(1:2*end/3))) 0.1*sin(10*t(2*end/3:end))],t);

    C4 = pole_assign(G, [0 -2*j 2*j], [ roots([1 2*0.7*1 1])'  roots([1 2*0.8*2 4])' -1  -3 ]);
    [T4, S4, Su4, Si4]=calc_sensibilidades(G,C4);
    y4 = lsim(T4, ones(size(t)), t) + lsim(Si4, [zeros(size(t(1:end/2))) 0.5*sin(2*t(end/2:end))], t) ...
        + lsim(S4, [zeros(size(t(1:end/3))) 0.5*sin(2*t(end/3:end))], t) ...
        + lsim(T4,[zeros(size(t(1:2*end/3))) 0.1*sin(10*t(2*end/3:end))],t);

    figure
    subplot(4,1,1), plot(t,y1), grid on
    subplot(4,1,2), plot(t,y2), grid on
    subplot(4,1,3), plot(t,y3), grid on
    subplot(4,1,4), plot(t,y4), grid on

    figure
    bode(T1,T2,T3,T4), grid on, legend('T1','T2','T3','T4')

end

